ss		equ	p1.4
mosi		equ	p1.5
miso		equ	p1.6
sck		equ	p1.7
ss20		equ	p2.4
mosi20		equ	p2.5 ; patmel3 PDIP20 socket SPI
miso20		equ	p2.6
sck20		equ	p2.7
nres20		equ	p3.2 ; patmel3 PDIP20 reset (nres20 = 0 => PDIP20.reset = 1)
nvpp		equ	p3.5 ; patmel3 Vpp (nvpp = 0 => PDIP40.VPP = Vpp; nvpp = 0 & nres20 = 0 => PDIP20.reset = Vpp)
res		equ	p1.0 ;!!!???  - in PAtmel3 there is hardwired reset to Vcc on PDIP40 socket
clk20		equ	p0.7 ; patmel3 PDIP20.xtal1
prog20		equ	p3.6 ; patmel3 PDIP20.6  ~ AT89Cx051 PROG (P3.2)
p3320		equ	p3.7 ; patmel3 PDIP20.7  ~ AT89Cx051 P3.3
enable20	equ	p0.6 ; patmel3 PDIP20.8  ~ AT89Cx051 ENABLE (P3.4)
p3520		equ	p0.5 ; patmel3 PDIP20.9  ~ AT89Cx051 P3.5
p3720		equ	p0.4 ; patmel3 PDIP20.11 ~ AT89Cx051 P3.7
led		equ	p3.4
rdy20		equ	led  ; patmel3 PDIP20.3 ~ AT89Cx051 RDY (P3.1) common with led output
resisp		equ	res
sckisp		equ	p0.0
misoisp		equ	p1.2
mosiisp		equ	p1.3

escape		equ	0A5h ; escape character - A55A = communication reset, A5A5 = A5
escrescom	equ	05Ah ; communication reset

                dseg at 21h
                org     21h
FLGS:           ds      2               ;
flgs_cmd        bit     (FLGS-20h)*8    ; FLGS.0 - command received
flgs_len        bit     (FLGS-20h)*8+1  ; FLGS.1 - length received
flgs_esc	bit	(FLGS-20h)*8+2	; FLGS.2 - escape received
flgs_clk20	bit	(FLGS-20h)*8+3  ; FLGS.3 - run clk to PDIP20.xtal1
flgs_clk20s	bit	(FLGS-20h)*8+4	; FLGS.4 - status of PDIP20.xtal1 if is not running
b2s:		ds	1		; bits to send
sph:		ds	1		; sck phase
B2r:		ds	1		; bytes to receive (to the end of block)
cmd:		ds	1		; command
cmd_20	        bit     (cmd-20h)*8+4   ; command.4 - use SPI for patmel3 PDIP20 socket instead of std spi
cmd_isp	        bit     (cmd-20h)*8+5   ; command.5 - use SPI for patmel3 ISP connector instead of std spi
outb:		ds	1
inb:		ds	1
titlelen	equ	23 ;titleend+1-title
titlemem:	ds	titlelen

sysstack:	ds	32		; system stack - should be leaved as a last RAM item

                cseg at 0
                ORG      0000H
                JMP      START
                ORG      0003H           ;EXTERNAL INT 0
                RETI     
                ORG      000BH           ;TIMER 0
                JMP      TIM0
                ORG      0013H           ;EXTERNAL INT 1
;                JMP      GETDATA
                RETI     
                ORG      001BH           ;TIMER 1
                reti     

                org   0023h           ; serial
                jmp   SERIO
                           
                ORG     00E0H
title:		db	'++incLudus loader 0.3c'
titleend:	db	0
START:
		clr	res
		clr	sck
		setb	miso
		setb	miso20
		clr	mosi
		clr	mosi20
                MOV     SP,#sysstack
                MOV     TH0,#095h   ; @18.432MHz cca.70us    ;#0CDh cca.33.5us   ;#256-50; @12MHz 50us => 20kHz => 5kHz sck
                MOV     TMOD,#00100010B; timer 0 autoreload 
                MOV    	IE,#010010010B         ;EA,ES,ET0 ON
                mov	TH1,#236  ; @18.432MHz 2400 baud (#246; 4800 baud)        ;#230 ; @12MHz 1200 baud a nějaký drobný
                clr	a
                mov	sph,#3    ; sck phase
                mov	b2s,a	 ; bits to send
                mov	B2s,a
                mov	FLGS,a
                setb	FLGS_clk20s
                mov	dptr,#title
                mov	r0,#titlemem
                dec	r0
filltitlemem:
		inc	r0
		inc	dptr
		clr	a
		movc    a,@a+dptr
		mov	@r0,a
		jnz	filltitlemem
		clr	nres20
		setb  	tr1
                mov	SCON,#01010000B
                setb	tr0
mainloop:
		jnb	FLGS_clk20,noclk
		cpl	clk20
		jmp	mainloop
noclk:		mov	c,FLGS_clk20s
		mov	clk20,c
		jmp	mainloop

;		mov	c,clk20
;		anl	c,flgs_clk20
;		cpl	c
;		mov	clk20,c
;		jmp	mainloop

TIM0:
		push	acc
		push	psw
		mov	psw,#08h
		mov	a,b2s
		jz	TIM0r

		clr	led

		mov	a,sph
		rl	a
		mov	dptr,#TIM0jt
		jmp	@a+dptr
TIM0jt:
		ajmp	TIM0phend	; 0
		ajmp	TIM0miso	; 1
		ajmp	TIM0sckup	; 2
		mov	a,outb		; 3
		rlc	a
		jb	cmd_20,TIM0mosi20
		jb	cmd_isp,TIM0mosiisp
		mov	mosi,c
		sjmp	TIM0mosi40
TIM0mosi20:	mov	mosi20,c
		sjmp	TIM0mosi40
TIM0mosiisp:	mov	mosiisp,c
TIM0mosi40:		
		mov	outb,a
		jmp	TIM0phstep
TIM0miso:
		mov	a,inb
		jb	cmd_20,TIM0miso20
		jb	cmd_isp,TIM0misoisp
		mov	c,miso
		sjmp	TIM0miso40
TIM0miso20:	mov	c,miso20
		sjmp	TIM0miso40
TIM0misoisp:	mov	c,misoisp
TIM0miso40:
		rlc	a
		mov	inb,a
		clr	c
		call	SCKO
		mov	a,#1
		sjmp	TIM0phstep
TIM0sckup:
		setb	c
		call	SCKO
		nop		
TIM0phstep:
		dec	sph
		jmp	TIM0r
TIM0phend:
		clr	c
		call	SCKO

		mov	sph,#3
		djnz	b2s,TIM0r
		setb	mosi
		setb	mosi20
		setb	mosiisp
		mov	SBUF,inb
		setb	led
TIM0r:
		pop	psw
		pop	acc
		reti
SCKO:
		jb	cmd_20,SCKO20
		jb	cmd_isp,SCKOisp
		mov	sck,c
		sjmp	SCKO40
SCKO20:		mov	sck20,c
		sjmp	SCKO40
SCKOisp:	mov	sckisp,c
SCKO40:		
		ret

SERIO:
		push	acc
		push	dpl
		push	dph
		push	psw
		mov	psw,#18h
		jnb	RI,SERIOy		; nothing has arrived (interruption from send)
		mov	a,SBUF
		jb	flgs_esc,SERIOesc
		cjne	a,#escape,SERIOcmd
		setb	flgs_esc
		jmp	SERIOx
SERIOcmd:	jb	flgs_cmd,SERIOlen
		mov	cmd,SBUF		; command just has been received
		setb	flgs_cmd
		clr	flgs_len
		jmp	SERIOx
SERIOlen:	jb	flgs_len,SERIOdocmd
		mov	B2r,SBUF		; block length just has been received
		setb	flgs_len
		jmp	SERIOx
SERIOesc:	clr	flgs_esc
		cjne	a,#escrescom,SERIOcmd
		clr	flgs_cmd
		jmp	SERIOx
SERIOdocmd:	
		djnz	B2r,SERIOdocmd10
		clr	flgs_len
		clr	flgs_cmd
SERIOdocmd10:		
		mov	a,cmd
		
		anl	a,#07h
		rl	a
		mov	dptr,#SERIOdocmd20
		jmp	@a+dptr
SERIOdocmd20:	ajmp	reset_on_off		; 0 ; 01b -> reset (not implemented in patmel3) 10b -> PDIP20.reset ... and other ... see routine
		ajmp	teser_on_off		; 1 ; similar to 0 - see routine
		ajmp	spiblk			; 2 ; spi block
		ajmp	noop			; 3
		ajmp	Cx051write		; 4 ; special function for AT89Cx051 - parallel write
		ajmp	Cx051read		; 5 ; special function for AT89Cx051 - parallel read
		ajmp	Cx051erase		; 6 ; special function for AT89Cx051 - parallel erase
		clr	led
		mov	r0,SBUF			; 7 - get ram byte
		mov	SBUF,@r0
		setb	led
		jmp	SERIOx
spiblk:
		mov	outb,SBUF
		mov	b2s,#8
noop:		
SERIOx:
		clr	RI
		jmp	SERIOr
SERIOy:
		clr	TI
SERIOr:
		pop	psw
		pop	dph
		pop	dpl
		pop	acc
		reti

reset_on_off:	
		clr	led
		mov	a,SBUF
		rrc	a
		mov	res,c			; xxxxxxxC reset
		rrc	a
		cpl	c
		mov	nres20,c		; xxxxxxCx PDIP20.reset
		rrc	a
		mov	sck,c			; xxxxxCxx PDIP40.sck
		rrc	a
		mov	sck20,c			; xxxxCxxx PDIP20.sck
		rrc	a
		mov	ss,c			; xxxCxxxx PDIP40.ss
		rrc	a
		mov	ss20,c			; xxCxxxxx PDIP20.ss
		rrc	a
		mov	FLGS_clk20,c		; xCxxxxxx run/stop PDIP20.xtal1 clk
		rrc	a
		mov	sckisp,c		; Cxxxxxxx ISP.sck
		setb	led
		jmp	SERIOx

teser_on_off:	
		clr	led
		mov	a,SBUF
		rrc	a
		mov	p3520,c			; xxxxxxxC 
		rrc	a
		mov	p3720,c			; xxxxxxCx
		rrc	a
		mov	FLGS_clk20s,c		; xxxxxCxx
		setb	led
		jmp	SERIOx

Cx051write:
		call	Cx051init
		mov	a,SBUF
		call	Cx051wb
		mov	SBUF,#0 ; reply something for compatibility with current uploader
		jmp	SERIOx

Cx051read:
		clr	led
		call	Cx051init
		call	Cx051rb ; get a byte after any received byte - this strange behavior is also for compatibility with uploader
		mov	SBUF,a
		setb	led
		jmp	SERIOx

Cx051erase:
		call	Cx051init
		call	Cx051ce
		jmp	SERIOx

Cx051init:	; AT89Cx051 initializacion
		clr	nres20
		clr	clk20
		setb	prog20
		clr	enable20
		ret
		
Cx051wb:	; AT89Cx051 write byte in ACC
		clr	p3320
		setb	enable20
		setb	p3520
		setb	p3720
		setb	rdy20 ; clear to receive RDY signal
		clr	nvpp
		mov	p2,a ; PDIP20 12-19 ~ AT89Cx051 P1
		mov	r1,#7
		djnz	r1,$ ; wait for 10uS from setting up VPP
		clr	prog20
		nop
		setb	prog20
		mov	r1,#6
		djnz	r1,$ ; wait for 10uS from setting up PROG
		setb	nvpp
		jnb	rdy20,$ ; wait for rdy20
		nop
		nop
		setb	clk20
		nop
		nop
		nop
		clr	clk20
		ret

Cx051rb:	; AT89Cx051 read byte in ACC
		clr	p3320
		clr	enable20
;		setb	p3520    ; should be set previously by command 1 (1, 1 means read prg memory, 0, 0 menas read signature bytes)
;		setb	p3720
		mov	p2,#0FFh ; clear P2 to receive data from AT89Cx051 P1
		nop
		mov	a,p2
		setb	clk20
		nop
		nop
		nop
		clr	clk20
		ret

Cx051ce:	; AT89Cx051 chip erase
		setb	p3320
		clr	enable20
		clr	p3520
		clr	p3720
		clr	nvpp
		mov	r1,#8
		djnz	r1,$
		clr	prog20
		mov	r3, #02h ; wait 10ms
		mov	r2, #99h
		mov	r1, #17h
		nop
		djnz	r1, $
		djnz	r2, $-5
		djnz	r3, $-9
		mov	r1, #01Ah
		djnz	r1, $  ; wait 10ms end
		setb	prog20
		mov	r1,#6
		djnz	r1,$ ; wait for 10uS from setting up PROG
		setb	nvpp
		ret

		end